from cocos.director import director
from cocos.layer import Layer, ColorLayer
from cocos.actions import *
from cocos.scene import Scene
from cocos.sprite import *

import pyglet
from pyglet import gl, font
from pyglet.window import key

import soundex

import random

class storyBoard(Layer):

    is_event_handler = True     #: enable pyglet's events

    def __init__( self ):
        super(storyBoard, self).__init__()
        self.text_pressKey = pyglet.text.Label("Press ENTER to continue, q to end intro",
            font_size=16,
            x=director.get_window_size()[0] /2,
            y=20,
            anchor_x=font.Text.CENTER,
            anchor_y=font.Text.CENTER)

    def on_draw(self):
        self.text_pressKey.draw()

    def on_key_press( self, k , m ):
        if k == key.ENTER:
            self.next_sb()

        if k == key.Q:
            director.pop()


class storyBoard4(storyBoard):

    def __init__( self ):
        super(storyBoard4, self).__init__()

        self.background = Sprite('Fondo 001.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1] /2
        self.background.scale = 1
        self.add(self.background, z=0)

        self.stringR = Sprite('Soga a 004.png')
        self.stringR.position = director.get_window_size()[0] + 1000, -1000
        self.add(self.stringR, z=1)

        self.stringL = Sprite('Soga b 004.png')
        self.stringL.position = -1000, -1000
        self.add(self.stringL, z=1)


    def on_enter(self):
        super(storyBoard4, self).on_enter()
        self.do( CallFunc(self.move_string1) + Delay(2) +
                 CallFunc(self.move_string2) + Delay(2) + CallFunc(self.next_sb) )

    def move_string1(self):
        self.stringR.do(MoveTo( (-1000, 2*director.get_window_size()[1]), duration=2) )

    def move_string2(self):
        self.stringL.do(MoveTo( (2*director.get_window_size()[0], 2*director.get_window_size()[1]), duration=2) )

    def next_sb(self):
        director.replace( Scene(storyBoard5()) )

class storyBoard5(storyBoard):

    def __init__( self ):
        super(storyBoard5, self).__init__()
        self.gaucho = Sprite('Marioneta gil 005.jpg')
        self.gaucho.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.gaucho)

    def on_enter(self):
        super(storyBoard5, self).on_enter()
        self.do( CallFunc(self.show_gaucho) + Delay(0.5) + CallFunc(self.next_sb) )

    def show_gaucho(self):
        self.do(ScaleBy(1.5, 1))

    def next_sb(self):
        director.replace( Scene(storyBoard9()) )

class storyBoard9(storyBoard):

    def __init__( self ):
        super(storyBoard9, self).__init__()

        self.background = Sprite('Marioneta gil 009.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.background, z=0)

        self.strings = Sprite('Soga 009.png')
        self.strings.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.strings.scale = 1
        self.add(self.strings, z=1)

    def on_enter(self):
        super(storyBoard9, self).on_enter()
        self.do( CallFunc(self.move_strings) + Delay(1) + CallFunc(self.next_sb) )

    def move_strings(self):
        self.strings.do(ScaleBy(0.2, 4) )

    def next_sb(self):
        director.replace( Scene(storyBoard10()) )

class storyBoard6(storyBoard):

    def __init__( self ):
        super(storyBoard6, self).__init__()
        self.gaucho = Sprite('Marioneta gil 009.jpg')
        self.gaucho.position = director.get_window_size()[0]/2, director.get_window_size()[1] /2
        self.gaucho.scale = 1
        self.add(self.gaucho, z=1)

        self.string1 = Sprite('Soga a 006.png')
        self.string1.position = director.get_window_size()[0]/2, 0
        self.string1.scale = 0.8
        self.add(self.string1, z=2)

        self.string2 = Sprite('Soga b 006.png')
        self.string2.position = director.get_window_size()[0]/2, 0
        self.string2.scale = 0.8
        self.add(self.string2, z=2)

    def on_enter(self):
        super(storyBoard6, self).on_enter()
        self.do( CallFunc(self.move_strings) + Delay(2) + CallFunc(self.next_sb) )

    def move_strings(self):
        self.string1.do(MoveTo( (director.get_window_size()[0]/2, 10*director.get_window_size()[1]), duration=5) )
        self.string2.do(MoveTo( (director.get_window_size()[0]/2, 10*director.get_window_size()[1]), duration=5) )

    def next_sb(self):
        director.replace( Scene(storyBoard10()) )



class storyBoard10(storyBoard):

    def __init__( self ):
        super(storyBoard10, self).__init__()

        self.background = Sprite('Marioneta gil mano 010.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.background, z=0)

        self.strings = Sprite('Soga 010.png')
        self.strings.position = -20, -100
        self.add(self.strings, z=1)

        #sprite for flashes.
        self.flash = Sprite( 'flash.png')
        self.flash.visible = False
        self.flash.scale = 1
        self.add(self.flash, z=2)

        self.crash = soundex.load('crash.mp3')

    def on_enter(self):
        super(storyBoard10, self).on_enter()
        self.do( CallFunc(self.move_string) + Delay(1.5) +
                 CallFunc(self.gen_flash) + Delay(0.1) + CallFunc(self.next_sb) )

    def gen_flash(self):
        self.flash.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.flash.visible = True
        self.flash.do( ScaleTo( 20, 0.1 ) + ScaleTo(0, 0) )

        if soundex.have_avbin:
            self.crash.play()

    def move_string(self):
        self.strings.do(Accelerate(
                         MoveTo( (director.get_window_size()[0]/2, director.get_window_size()[1]/2), duration = 1.5)
                        , 4 ) )

    def next_sb(self):
        director.replace( Scene(storyBoard11()) )

class storyBoard11(storyBoard):

    def __init__( self ):
        super(storyBoard11, self).__init__()
        self.background = Sprite('Marioneta gil piernas 011.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.background, z=0)

        self.stringL = Sprite('Soga 011a.png')
        self.stringL.position = -100, director.get_window_size()[1]
        self.add(self.stringL, z=1)

        self.stringR = Sprite('Soga 011b.png')
        self.stringR.position = 1.5*director.get_window_size()[0], 600
        self.add(self.stringR, z=1)

        #sprite for flashes.
        self.flash = Sprite( 'flash.png')
        self.flash.visible = False
        self.flash.scale = 1
        self.add(self.flash, z=2)

        self.crash = soundex.load('crash.mp3')

    def on_enter(self):
        super(storyBoard11, self).on_enter()
        self.do( CallFunc(self.move_stringL) + Delay(0.5) +
                 CallFunc(self.gen_flashL) + Delay(0.5) +
                 CallFunc(self.move_stringR) + Delay(0.5) +
                 CallFunc(self.gen_flashR) + Delay(0.1) + CallFunc(self.next_sb) )

    def move_stringR(self):
        self.stringR.do(MoveTo( (director.get_window_size()[0]-30, 290), duration = 0.5) )

    def gen_flashR(self):
        self.flash.position = 450, 140
        self.flash.visible = True
        self.flash.do( ScaleTo( 20, 0.1 ) + ScaleTo(0, 0) )

        if soundex.have_avbin:
            self.crash.play()

    def move_stringL(self):
        self.stringL.do(MoveTo( (30, 400), duration = 0.5) )

    def gen_flashL(self):
        self.flash.position = 200, 140
        self.flash.visible = True
        self.flash.do( ScaleTo( 20, 0.1 ) + ScaleTo(0, 0) )

        if soundex.have_avbin:
            self.crash.play()

    def next_sb(self):
        director.replace( Scene(storyBoard12()) )

class storyBoard12(storyBoard):

    def __init__( self ):
        super(storyBoard12, self).__init__()
        self.background = Sprite('Marioneta gil 012.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.background, z=0)

        self.strings = Sprite('Soga 012.png')
        self.strings.position = 1.5*director.get_window_size()[0], director.get_window_size()[1]/2
        self.add(self.strings, z=1)

        #sprite for flashes.
        self.flash = Sprite( 'flash.png')
        self.flash.visible = False
        self.flash.scale = 1
        self.add(self.flash, z=2)
        self.crash = soundex.load('crash.mp3')

    def on_enter(self):
        super(storyBoard12, self).on_enter()
        self.do( CallFunc(self.move_strings) + Delay(1.2) +
                 CallFunc(self.gen_flash) + Delay(0.1) + CallFunc(self.next_sb) )

    def gen_flash(self):
        self.flash.position = director.get_window_size()[0]/2, director.get_window_size()[1] - 40
        self.flash.visible = True
        self.flash.do( ScaleTo( 20, 0.1 ) + ScaleTo(0, 0) )

        if soundex.have_avbin:
            self.crash.play()

    def move_strings(self):
        self.strings.do(MoveTo( (director.get_window_size()[0]/2, director.get_window_size()[1]/2), duration = 1.2) )

    def next_sb(self):
        director.replace( Scene(storyBoard14()) )


class storyBoard14(storyBoard):

    def __init__( self ):
        super(storyBoard14, self).__init__()
        self.background = Sprite('Marioneta gil 014.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.background, z=0)

    def on_enter(self):
        super(storyBoard14, self).on_enter()
        self.do( Delay(1) + CallFunc(self.show_background) + Delay(2) +
                 CallFunc(self.move_background) + Delay(0.5) +CallFunc(self.next_sb) )

    def show_background(self):
        self.background.do( MoveBy( (0, -100), 0.8) )

    def move_background(self):
        self.background.do(Blink(0.2,0.5))

    def next_sb(self):
        director.replace( Scene(storyBoard15()) )

class storyBoard15(storyBoard):

    def __init__( self ):
        super(storyBoard15, self).__init__()

        self.background = Sprite('Marioneta gil 015.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.background, z=0)

    def on_enter(self):
        super(storyBoard15, self).on_enter()
        self.do( Delay(2) + CallFunc(self.next_sb) )

    def next_sb(self):
        director.replace( Scene(storyBoard16()) )

class storyBoard16(storyBoard):

    def __init__( self ):
        super(storyBoard16, self).__init__()

        self.background = Sprite('Marioneta gil 015.jpg')
        self.background.position = director.get_window_size()[0]/2, director.get_window_size()[1]/2
        self.add(self.background, z=0)

    def on_enter(self):
        super(storyBoard16, self).on_enter()
        self.do( CallFunc(self.show_background) + Delay(1) + CallFunc(self.next_sb) )

    def show_background(self):
        self.transform_anchor = 520, 500
        self.do(ScaleBy( 5, 1 ) )

    def next_sb(self):
        director.pop()