from pyglet.window import key
import cPickle
from glob import glob
import random

## actions_specs = {
##      0:{'name': 'IDLE',       'rounds': 1, 'ctrl_keys': None},
##      1:{'name': 'MOVE_LEFT',  'rounds': 1, 'ctrl_keys': key.LEFT},
##      2:{'name': 'MOVE_RIGHT', 'rounds': 1, 'ctrl_keys': key.RIGHT},
##      3:{'name': 'CROUCH',     'rounds': 1, 'ctrl_keys': key.DOWN},
##      4:{'name': 'JUMP',       'rounds': 3, 'ctrl_keys': key.UP},
##      5:{'name': 'JUMP_LEFT',  'rounds': 3, 'ctrl_keys': [key.UP,key.LEFT]},
##      6:{'name': 'JUMP_RIGHT', 'rounds': 3, 'ctrl_keys': [key.UP,key.RIGHT]},
##      7:{'name': 'DEFEND',     'rounds': 1, 'ctrl_keys': key.A},
##      8:{'name': 'PUNCH',      'rounds': 1, 'ctrl_keys': key.S},
##      9:{'name': 'PUNCH_HIGH', 'rounds': 1, 'ctrl_keys': key.W},
##     10:{'name': 'KICK',       'rounds': 2, 'ctrl_keys': key.D},
##     11:{'name': 'KICK_HIGH',  'rounds': 2, 'ctrl_keys': key.E},
##     12:{'name': 'KICK_LOW',   'rounds': 2, 'ctrl_keys': key.C},
##     13:{'name': 'POWER_BLOW',   'rounds': 2, 'ctrl_keys': key.C},
##     14:{'name': 'TURN_AROUND','rounds': 3, 'ctrl_keys': key.TAB,}, # o None y que se de vuelta solo
##     98:{'name': 'CONTINUE',   'rounds': 1, 'ctrl_keys': None},
##     99:{'name': 'DAMAGED',    'rounds': 1, 'ctrl_keys': None},
##     }

# set reducido:
actions_specs ={
        0:{'name': 'IDLE',       'rounds': 1, 'ctrl_keys': None},
        1:{'name': 'MOVE_BACK',  'rounds': 1, 'ctrl_keys': (key.LEFT,)},
        2:{'name': 'MOVE_FORWARD', 'rounds': 1, 'ctrl_keys': (key.RIGHT,)},
        3:{'name': 'PUNCH',      'rounds': 1, 'ctrl_keys': (key.S,)},
        4:{'name': 'DEFEND',     'rounds': 1, 'ctrl_keys': (key.A,)},
        5:{'name': 'KICK',       'rounds': 2, 'ctrl_keys': (key.D,)},
        6:{'name': 'JUMP',       'rounds': 3, 'ctrl_keys': (key.UP,)},
        7:{'name': 'JUMP_LEFT',  'rounds': 3, 'ctrl_keys': (key.UP, key.LEFT)},
        8:{'name': 'JUMP_RIGHT', 'rounds': 3, 'ctrl_keys': (key.UP, key.RIGHT)},
        9:{'name': 'PUNCH_HI',   'rounds': 1, 'ctrl_keys': (key.W,)},
       10:{'name': 'DEFEND_HI',  'rounds': 1, 'ctrl_keys': (key.Q,)},
       11:{'name': 'KICK_HI',    'rounds': 2, 'ctrl_keys': (key.E,)},
       95:{'name': 'TIRED',      'rounds': 1, 'ctrl_keys': None},
       96:{'name': 'WIN',        'rounds': 3, 'ctrl_keys': None},
       97:{'name': 'DIE',        'rounds': 1, 'ctrl_keys': None},
       98:{'name': 'CONTINUE',   'rounds': 1, 'ctrl_keys': None},
    }


keys_to_action = {}

for action_id, action_spec in actions_specs.items():
    anims = []
    ## Ugly
    locals().__setitem__(action_spec['name'], action_id)

    action_name = actions_specs[action_id]['name']
    anim_filenames = glob('data/'+ action_name +"?.anim")

    for filename in anim_filenames:
        anims.append( cPickle.load(open(filename)))

    actions_specs[action_id]['anims'] = anims

    keys_to_action[action_spec['ctrl_keys']] = action_id


def get_action_anim(selected_action):
    return random.choice(actions_specs[selected_action]['anims'])
