from cocos.particle import ParticleSystem, Color
from cocos.euclid import Point2


class Sun( ParticleSystem ):

    # total particles
    total_particles = 200

    # duration
    duration = -1

    # gravity
    gravity = Point2(0,0)

    # angle
    angle = 90.0
    angle_var = 360.0

    # speed of particles
    speed = 8
    speed_var = 1.0

    # radial
    radial_accel = 0
    radial_accel_var = 0

    # tangential
    tangential_accel = 0.0
    tangential_accel_var = 0.0

    # emitter variable position
    pos_var = Point2(0, 0)

    # life of particles
    life = 0.5
    life_var = 0.2

    # emits per frame
    emission_rate = total_particles / life

    # color of particles
    start_color = Color(0.75, 0.25, 0.12, 1.0)
    start_color_var = Color(0.0, 0.0, 0.0, 0.0)
    end_color = Color(1, 0.0, 0.0, 0.0)
    end_color_var = Color(0.5, 0.0, 0.0, 0.0)

    # size, in pixels
    size = 90.0
    size_var = 00.0

    # blend additive
    blend_additive = True

    # color modulate
    color_modulate = True